/*
 * dvdselect.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 */

#include <getopt.h>
#include <stdlib.h>
#include <vdr/interface.h>
#include <vdr/plugin.h>
#include "i18n.h"
#include "menuitem.h"
#include "menusetup.h"
#include "menu.h"

static const char *VERSION       = "0.5";
static const char *DESCRIPTION   = "DVD-Device Mounter";
static const char *MAINMENUENTRY = "DVDSelect (by Sligers)";

class cPluginDVDSelect : public cPlugin {
 private:
  // Add any member variables or functions you may need here.
 public:
  cPluginDVDSelect(void);
  virtual ~cPluginDVDSelect();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return tr(DESCRIPTION); }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Start(void);
  virtual bool Initialize(void);
  virtual void Housekeeping(void);
  virtual const char *MainMenuEntry(void) { return tr(MAINMENUENTRY); }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
};

// Global variables that control the overall behaviour:


// --- cPluginDVDSelect -------------------------------------------------------

cPluginDVDSelect::cPluginDVDSelect(void)
{
}

cPluginDVDSelect::~cPluginDVDSelect()
{
  // Clean up after yourself!
}

const char *cPluginDVDSelect::CommandLineHelp(void)
{
  return "";
}

bool cPluginDVDSelect::ProcessArgs(int argc, char *argv[])
{
  return true;
}

bool cPluginDVDSelect::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  RegisterI18n(Phrases);
  return true;
}

bool cPluginDVDSelect::Start(void)
{
  // Start any background activities the plugin shall perform.
  return true;
}

void cPluginDVDSelect::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPluginDVDSelect::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  //	return new cMenuDVDList;
  
  return new cDVDList();
  //	return NULL;
}

cMenuSetupPage *cPluginDVDSelect::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return new cMenuDVDSelectSetup;
}

bool cPluginDVDSelect::SetupParse(const char *Name, const char *Value)
{
  if (!strcasecmp(Name, "NameDevice"))              strn0cpy(config.NameDevice, Value, MaxFileName);
  else if (!strcasecmp(Name, "NameOrgDevice"))              strn0cpy(config.NameOrgDevice, Value, MaxFileName);
  else if (!strcasecmp(Name, "ImageDir"))              strn0cpy(config.ImageDir, Value , MaxFileName);
  
  else
     return false;

  return true;
}

VDRPLUGINCREATOR(cPluginDVDSelect); // Don't touch this!
