#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <getopt.h>
#include <stdlib.h>
#include <vdr/interface.h>
#include <vdr/plugin.h>
#include <unistd.h>
#include "menu.h"
#include "menusetup.h"
#include "menuitem.h"

#define ISOEXT       "*.ISO"
//#define FINDCMD      "cd '%s' && find '%s' -follow -type f -iname '%s' 2> /dev/null"
#define TSDIR        "video_ts"
#define FINDCMD      "cd '%s' && find '%s' -follow -iname '%s' -printf '%%p\n' -o -iname '%s' -printf '%%h\n' 2> /dev/null"

#define RMCMD      "rm '%s' 2> /dev/null"
#define MOUNTCMD      "ln -s '%s' '%s' 2> /dev/null"
#define RESETCMD      "ln -s '%s' '%s' 2> /dev/null"
#define BURNCMD   "/usr/local/src/CONFIG/scripts/dvdburn.sh '%s' > /dev/tty8 &"

// --- cDVDList -------------------------------------------------------------
cDVDList::cDVDList(void) : cOsdMenu(NULL, 12, 6)
{
  int i;
  char *cmd = NULL;
  bool result = false;
  
  SetTitle();
  SetHelp();
  
  asprintf(&cmd, FINDCMD, config.ImageDir, config.ImageDir, ISOEXT,TSDIR);
//  asprintf(&cmd, FINDCMD, config.ImageDir, config.ImageDir, "*" ISOEXT);
  FILE *p = popen(cmd, "r");
  if (p) {
    char *s;
    while ((s = readline(p)) != NULL) {
      Add(new cMenuDVDItem(s,config.ImageDir), &i);
    }//while
    pclose(p);
    Sort();
    result = Count() > 0;
  }
  else
    Interface->Error("Error while opening pipe!");
  free(cmd);
  
}


cDVDList::~cDVDList()
{
}

eOSState cDVDList::ProcessKey(eKeys Key)
{
  eOSState state = cOsdMenu::ProcessKey(Key);
  
  if (state == osUnknown) {
    
    switch (Key) {
    case kOk:
      return Mount();
      
    case kRed:
      return Delete();
      
    case kGreen:
      return Start();
      
    case kYellow:
      return Burn();

    case kBlue:
      return Reset();
      
    default:
      break;
    }//switch
  }//if
  return state;
}

//Sligers modded
eOSState cDVDList::Burn() {
  int rc=0;
  char *cmd = NULL;
  cMenuDVDItem *item = (cMenuDVDItem*)Get(Current());
  if (item) {
    esyslog(cmd);
    asprintf(&cmd, BURNCMD, item->dateiname);
    rc=system(cmd);
    }
    return osEnd;
}


eOSState cDVDList::Delete() {
  int rc=0;
  char *cmd = NULL;
  
  cMenuDVDItem *item = (cMenuDVDItem*)Get(Current());
  if (item) {
    
    esyslog(cmd);
    asprintf(&cmd, RMCMD, item->dateiname);
    rc=system(cmd);
  }
  
  //Nach Lschen Men ausblenden,
  //da es neu aufgebaut werden mu.
  return osEnd;
}

eOSState cDVDList::Mount() {
  int rc=0;
  cMenuDVDItem *item = (cMenuDVDItem*)Get(Current());
  if (item) {
    //      SetItemsDirty();
    Interface->Status("Mounte");
    char *cmd = NULL;
    char *device = NULL;
    //	bool result = false;
    
    asprintf(&device, "%s",config.NameDevice);
    
    asprintf(&cmd, RMCMD, device);
    rc=system(cmd);
    esyslog(cmd);
    /*
    //Debugausgabe:
    if (rc==0){
    Interface->Status("erfolgreich 1");
    }else{
    Interface->Error("Fehler 1!");
    }
    */
    
    asprintf(&cmd, MOUNTCMD, item->dateiname, device);
    //Debugausgabe:
    //	Interface->Status(cmd);
    rc=system(cmd);
    esyslog(cmd);
    /*
    //Debugausgabe:
    if (rc==0){
    Interface->Status("erfolgreich");
    }else{
    Interface->Error("Fehler!");
    }
    */
  }
  
  return osContinue;
}

//Undo mounting
eOSState cDVDList::Reset() {
  int rc=0;
    //      SetItemsDirty();
    Interface->Status("Resette");
    char *cmd = NULL;
    char *device = NULL;
    char *orgDevice = NULL;
    //	bool result = false;
    
    asprintf(&device, "%s",config.NameDevice);
    asprintf(&orgDevice, "%s",config.NameOrgDevice);
    
    asprintf(&cmd, RMCMD, device);
    rc=system(cmd);
    esyslog(cmd);
    /*
    //Debugausgabe:
    if (rc==0){
    Interface->Status("erfolgreich 1");
    }else{
    Interface->Error("Fehler 1!");
    }
    */
    
    asprintf(&cmd, RESETCMD,orgDevice, device);
    //Debugausgabe:
    //	Interface->Status(cmd);
    rc=system(cmd);
    esyslog(cmd);
    /*
    //Debugausgabe:
    if (rc==0){
    Interface->Status("erfolgreich");
    }else{
    Interface->Error("Fehler!");
    }
    */
  
  return osContinue;
}

eOSState cDVDList::Start() {
  Mount();
  char dvdpluginname[100];
  strcpy(dvdpluginname,"dvd");

  for (int i = 0; ; i++) {
      cPlugin *p = cPluginManager::GetPlugin(i);
      if (p) {
	if (strcasecmp(dvdpluginname,p->Name())==0){
	  p->MainMenuAction();
	  break;
	} else{
	}
      }
      else{
	Interface->Error(tr("DVD-plugin not found!"));
	break;
      }
  }
  return osEnd;
}

void cDVDList::SetTitle() {
  
  cOsdMenu::SetTitle(tr("DVDSelect"), true);
}

void cDVDList::SetHelp() {
  
  //cOsdMenu::SetHelp(tr("delete"),tr("start"),0,tr("reset"));
   cOsdMenu::SetHelp(tr("delete"),tr("start"),tr("burn DVD"),tr("reset"));
}

